# -*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin
import sys
try:
    from urllib2 import urlopen
except ImportError:
    from urllib.request import urlopen
try:
    from urllib import urlencode
except ImportError:
    from urllib.parse import urlencode
try:
    from urlparse import urlparse, parse_qs
except ImportError:
    from urllib.parse import urlparse, parse_qs
if sys.version_info < (2, 7) or (3, 0) <= sys.version_info < (3, 1):
    import simplejson as json
    from simplejson import OrderedDict
else:
    import json
    from collections import OrderedDict
import localau


def play(title, url, header={}):
    listitem = xbmcgui.ListItem(title)
    if header:
        url += '|' + urlencode(header)
    xbmc.Player().play(url, listitem)


def resp(ret):
    if 'code' in ret:
        if 'error' in ret:
            return xbmcgui.Dialog().ok('Error: ' + ret['code'], ret['error'])
        return xbmcgui.Dialog().ok('Error', ret['code'])
    if isinstance(ret, list):
        for elem in ret:
            resp(elem)
        return xbmcplugin.endOfDirectory(handle)
    if 'url' in ret:
        if isinstance(ret['url'], list):
            ret['url'] = 'stack://' + ' , '.join(ret['url'])
        if isinstance(ret['url'], dict):
            for k, v in ret['url'].items():
                resp({'title': ret['title'], 'url': v, 'format': k})
            return xbmcplugin.endOfDirectory(handle)
    if 'final' in ret:
        return play(ret['title'], ret['url'])
    t = True
    if 'format' in ret:
        li = xbmcgui.ListItem(ret['format'])
        ret['final'] = True
        t = False
    else:
        li = xbmcgui.ListItem(ret['title'])
    if 'url' in ret:
        if ret['url'][:8] == 'stack://':
            return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
        o = urlparse(ret['url'])
        p = o.path.split('/')
        ext = p[-1].split('.')[-1]
        if ext in ('m3u', 'm3u8'):
            return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
        if t:
            t = sub1(ret['url'])
    for k in ret:
        if isinstance(ret[k], unicode):
            ret[k] = ret[k].encode('utf-8')
    xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode(ret), li, t)


def sub1(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    l = len(p)
    if o.netloc in ('sports.localau.com', 'www.tiyu6.tv', 'www.itiyu.tv'):
        if l > 1 and p[1] == 'play':
            return False
        if p[-1] == 'play.html':
            return False
    if o.netloc in ('www.localmv.com', 'www.localmv1.com', 'www.localmv.tv', 'www.iyingshi.tv', 'www.iyingshi6.com'):
        if l > 1 and p[1] == 'play':
            return False
    if o.netloc == 'api.localau.vip' and p[-1] in ('hv.php', 'live.html'):
        return False
    return True


def sub2(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    l = len(p)
    if o.netloc in ('sports.localau.com', 'www.tiyu6.tv', 'www.itiyu.tv'):
        if l > 1 and p[1] == 'game':
            return resp(localau.game(url))
        if l > 1 and p[1] == 'play':
            return resp(localau.sport(url))
        if p[-1] == 'play.html':
            return resp(localau.tv1(url))
    if o.netloc in ('www.localmv.com', 'www.localmv1.com', 'www.localmv.tv', 'www.iyingshi.tv', 'www.iyingshi6.com'):
        if l > 1 and p[1] == 'video':
            return resp(localau.video(url))
        if l > 1 and p[1] == 'play':
            return resp(localau.play(url))
    if o.netloc == 'api.localau.vip' and p[-1] == 'hv.php':
        return resp(localau.tv2(url))
    if o.netloc == 'api.localau.vip' and p[-1] == 'live.html':
        return resp(localau.tv3(url))
    if l > 1 and p[1] == 'tv':
        return resp(localau.tv(url))
    return resp({'code': 'localau 020', 'error': url})


def sub3(content):
    try:
        data = json.loads(content, object_pairs_hook=OrderedDict)
    except Exception as e:
        return resp({'code': 'cntv 030', 'error': str(e)})
    for k, v in data.items():
        if isinstance(v, dict):
            resp({'title': k, 'json': json.dumps(v)})
        else:
            resp({'title': k, 'url': v})
    xbmcplugin.endOfDirectory(handle)


def category(cat):
    if 'page' in q:
        page = int(q['page'][0])
    else:
        page = 1
    resp(localau.category(cat, page))


def sports():
    return resp(localau.sports())


def search(s):
    if not s:
        kb = xbmc.Keyboard(heading='Search')
        kb.doModal()
        if not kb.isConfirmed():
            return
        s = kb.getText()
    resp(localau.search(s))


def get_node(url):
    try:
        content = urlopen(url).read().decode('utf-8')
    except Exception as e:
        return resp({'code': 'localau 010', 'error': str(e)})
    sub3(content)


handle = int(sys.argv[1])
url = sys.argv[2]
if not url:
    resp({'title': '电影', 'category': 'dianying'})
    resp({'title': '电视剧', 'category': 'dianshiju'})
    resp({'title': '综艺', 'category': 'zongyi'})
    resp({'title': '动漫', 'category': 'dongman'})
    resp({'title': '纪录片', 'category': 'document'})
    resp({'title': '体育直播', 'sports': True})
    resp({'title': 'Search', 'search': ''})
    get_node('http://ims.tian-le.com/localau.json')
else:
    o = urlparse(url)
    q = parse_qs(o.query, True)
    if 'final' in q:
        play(q['title'][0], q['url'][0])
    elif 'json' in q:
        sub3(q['json'][0])
    elif 'url' in q:
        sub2(q['url'][0])
    elif 'category' in q:
        category(q['category'][0])
    elif 'sports' in q:
        sports()
    elif 'search' in q:
        search(q['search'][0])
