# -*- coding: utf-8 -*-
import sys, re
from bs4 import BeautifulSoup
try:
    from urllib2 import urlopen, Request
except ImportError:
    from urllib.request import urlopen, Request
try:
    from urlparse import urljoin, urlparse, parse_qs
except ImportError:
    from urllib.parse import urljoin, urlparse, parse_qs
try:
    from urllib import urlencode
except ImportError:
    from urllib.parse import urlencode
ua = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36'


def gethttp(url, data=None):
    request = Request(url)
    request.add_header('User-Agent', ua)
    return urlopen(request, data).read().decode('utf-8')


def getsoup(url, data=None):
    request = Request(url)
    request.add_header('User-Agent', ua)
    if (2, 7, 3) <= sys.version_info < (3, 0) or (3, 2) <= sys.version_info < (4, 0):
        return BeautifulSoup(urlopen(request, data), 'html.parser')
    return BeautifulSoup(urlopen(request, data), 'html5lib')


def video(url):
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'localau 100', 'error': str(e)}
    suburl = soup.find('a', {'class': 'video'})['href']
    return video2(urljoin(url, suburl))


def video2(url):
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'localau 101', 'error': str(e)}
    ret = []
    for e1 in soup.find('ul', {'class': 'aside-tabbox'})('li'):
        for e2 in e1.find_all('a'):
            title = e2.text
            ret.append({'title': title, 'url': urljoin(url, e2['href'])})
    return ret


def play(url):
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'localau 200', 'error': str(e)}
    url2 = soup.find('iframe', {'id': 'main'})['src']
    url3 = re.search(r'/player/player\.php\?(.*)', url2)
    if url3:
        return {'code': '跟我说一声' + url}
        # url3 = urljoin(url, url2)
        # url2 = httpget2(url3, url)
    url3 = re.search(r'yunbo.html\?url=(.*)', url2)
    if url3:
        url3 = url3.group(1)
        return {'title': '', 'url': url3, 'header': {'Referer': url}, 'final': True}
    return {'code': 'localau 201'}


def sports():
    url = 'http://www.tiyu6.tv/'
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'localau 300', 'error': str(e)}
    ret = []
    for e1 in soup.find_all('li', {'class': 'gamelist'}):
        title = []
        for e2 in e1.find_all(['span', 'div']):
            if 'style' in e2.attrs and 'display:none;' in e2['style']:
                continue
            if 'style' in e2.attrs and 'text-align:center;' in e2['style']:
                continue
            t = e2.find(text=True).strip()
            if not t:
                continue
            title.append(t)
        for e2 in e1.find_all(['span', 'div']):
            if 'style' in e2.attrs and 'display:none;' in e2['style']:
                continue
            if 'style' not in e2.attrs or 'text-align:center;' not in e2['style']:
                continue
            t = e2.find(text=True).strip()
            if not t:
                continue
            title.append(t)
        title = ' '.join(title)
        suburl = e1.a['href']
        ret.append({'title': title, 'url': urljoin(url, suburl)})
    return ret


def game(url):
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'localau 310', 'error': str(e)}
    ret = []
    e1 = soup.find('div', {'id': 'links'})
    if e1:
        for e2 in e1('a'):
            url = e2['href']
            if url[:31] == 'http://sports.localau.com/play/':
                ret.append({'title': e2.text, 'url': url})
    return ret


def sport(url):
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'localau 320', 'error': str(e)}
    p = soup.find('iframe', {'id': re.compile('main.*')})
    if not p:
        return {'code': 'localau 321'}
    if 'src' not in p.attrs:
        return {'code': 'localau 322'}
    url = urljoin(url, p['src'])
    id = re.search(r'play.html\?id=(.*)', url)
    if id:
        id = id.group(1)
        return {'title': '', 'url': 'http://live.centerch.com/%s.m3u8' % id, 'final': True}
    day = re.search(r'\?day=(.*)', url)
    if day:
        try:
            content = gethttp(url)
        except:
            return {'code': 'localau 323'}
        url = re.search(r'playurl\s*=\s*"(.*?)"', content)
        if not url:
            return {'code': 'localau 324'}
        url = url.group(1)
        return {'url': {'m3u8': url}}
    return {'code': 'localau 325'}


def tv(url):
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'localau 330', 'error': str(e)}
    ret = []
    for e in soup.find('div', {'class': 'v-panel-box'})('a', {'class': 'v-panel-bookmark'}):
        ret.append({'title': e.span.text, 'url': e['href']})
    return ret


def tv1(url):
    o = urlparse(url)
    q = parse_qs(o.query, True)
    if 'id' not in q:
        return {'code': 'localau 340'}
    return {'title': '', 'url': 'http://live.centerch.com/%s.m3u8' % q['id'][0], 'final': True}


def tv2(url):
    try:
        content = gethttp(url)
    except Exception as e:
        return {'code': 'localau 350', 'error': str(e)}
    dp = re.search(r'DPlayer\((.*?)\);', content, re.DOTALL)
    if not dp:
        return {'code': 'localau 351'}
    dp = dp.group(1)
    url2 = re.search(r'url:\s*(.*?),', dp, re.DOTALL)
    if not url2:
        return {'code': 'localau 352'}
    url2 = url2.group(1)
    if url2[0] == '"' and url2[-1] == '"':
        url2 = url2[1:-1]
    if url2[:2] == '//':
        url2 = 'http:' + url2
    return {'title': '', 'url': url2, 'final': True}


def tv3(url):
    o = urlparse(url)
    q = parse_qs(o.query, True)
    if 'url' not in q:
        return {'code': 'localau 360'}
    return {'title': '', 'url': q['url'][0], 'final': True}


def category(cat, page=1):
    url = 'http://www.iyingshi6.com/list/%s____%d.html' % (cat, page)
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'localau 400', 'error': str(e)}
    ret = []
    for e in soup.find('div', {'class': 'm-result-list'}).ul('li', {'class': 'm-result-list-item'}):
        suburl = e.find('a', {'class': 'u-video'})
        if not suburl or 'href' not in suburl.attrs:
            continue
        suburl = suburl['href']
        title = e.find('a', {'class': 'u-title'})
        if not title:
            continue
        ret.append({'title': title.text, 'url': urljoin(url, suburl)})
    ret.append({'title': 'Next Page', 'category': cat, 'page': page + 1})
    return ret


def search(s):
    url = 'http://www.iyingshi6.com/search/'
    try:
        soup = getsoup(url, urlencode({'wd': s}))
    except Exception as e:
        return {'code': 'localau 500', 'error': str(e)}
    ret = []
    try:
        for e1 in soup.find_all('div', {'class': 'tele_hd'}):
            e2 = e1.find('a', {'class': 'report-click'})
            if not e2 or 'href' not in e2.attrs:
                continue
            url2 = e2['href']
            if url2[:6] != '/play/' or url2[-5:] != '.html':
                continue
            url2 = url2[6:-5]
            url2 = urljoin(url, '/video/%s.html' % url2.split('-')[0])
            ret.append({'title': e2.text, 'url': url2})
    except:
        return {'code': 'localau 501'}
    return ret
